diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 1f744bec9..b1373963b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -9,6 +9,7 @@ import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.current.wire.WireHandler;
@@ -20,6 +21,7 @@ import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandManager;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.block.Block;
@@ -36,8 +38,6 @@ import net.minecraft.core.sound.BlockSound;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
@@ -54,7 +54,9 @@ import net.minecraft.core.world.lighting.LightingEngineLegacy;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkTilePos;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
@@ -69,6 +71,10 @@ import net.minecraft.core.world.weather.WeatherManager;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 import org.slf4j.Logger;
 
 public class World implements MutableWorldSource {
@@ -89,10 +95,11 @@ public class World implements MutableWorldSource {
     public final @NotNull List<@NotNull Entity> entities = new ObjectArrayList<>();
     private final @NotNull List<@NotNull Entity> entitiesToRemove = new ObjectArrayList<>();
     private final @NotNull TreeSet<@NotNull NextTickListEntry> tickNextTickList = new TreeSet<>();
+    private final @NotNull Set<@NotNull NextTickListEntry> tickNextTickSet = new HashSet<>();
     public final @NotNull List<@NotNull TileEntity> tileEntityList = new ObjectArrayList<>();
     public final @NotNull List<@NotNull Player> players = new ObjectArrayList<>();
     public final @NotNull List<@NotNull Entity> weatherEffects = new ObjectArrayList<>();
-    public final @NotNull List<@NotNull AABB> collidingBoundingBoxes = new ObjectArrayList<>();
+    public final @NotNull List<@NotNull AABBdc> collidingBoundingBoxes = new ObjectArrayList<>();
     public final @NotNull List<@NotNull LevelListener> listeners = new ObjectArrayList<>();
     private final @NotNull Set<@NotNull ChunkCoordinate> positionsToUpdate = new ObjectOpenHashSet<>();
     private final @NotNull List<@NotNull Entity> entityBuffer = new ObjectArrayList<>();
@@ -126,7 +133,7 @@ public class World implements MutableWorldSource {
     public int sleepPercent = 100;
     private long runtime = 0;
     public int dayCountLastTick;
-    
+
     public BiomeProvider biomeProvider;
     public AuroraProvider auroraProvider;
     public SeasonManager seasonManager;
@@ -136,27 +143,21 @@ public class World implements MutableWorldSource {
     private final @NotNull WireHandler wireHandler;
 
     //Usually called when a world is loaded or generated (Singleplayer & Server)
-    public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType)
-    {
+    public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType) {
         this.saveHandler = saveHandler;
         this.savedDataStorage = new SavedDataStorage(saveHandler);
         this.levelData = saveHandler.getLevelData();
 
-        this.isNewWorld = levelData == null;
+        this.isNewWorld = this.levelData == null;
 
         // Attempt to determine the correct dimension for this world
-        if(dimension != null)
-        {
+        if (dimension != null) {
             // Provided dimension
             this.dimension = dimension;
-        }
-        else if(levelData != null)
-        {
+        } else if (this.levelData != null) {
             // Dimension from level data
-            this.dimension = Dimension.getDimensionList().get(levelData.getDimension());
-        }
-        else
-        {
+            this.dimension = Dimension.getDimensionList().get(this.levelData.getDimension());
+        } else {
             // Default dimension
             this.dimension = Dimension.getDimensionList().get(0);
         }
@@ -164,54 +165,44 @@ public class World implements MutableWorldSource {
         this.dimensionData = saveHandler.getDimensionData(this.dimension.id);
 
         // Attempt to determine the correct world type for this world
-        if (worldType != null)
-        {
+        if (worldType != null) {
             // Provided world type
             this.worldType = worldType;
-        }
-        else if (dimensionData != null)
-        {
+        } else if (this.dimensionData != null) {
             // World type from dimension data
-            this.worldType = dimensionData.getWorldType();
-        }
-        else
-        {
+            this.worldType = this.dimensionData.getWorldType();
+        } else {
             // Default world type
             this.worldType = this.dimension.defaultWorldType;
         }
 
         boolean isNewWorld = false;
-        if(levelData == null)
-        {
-            levelData = new LevelData(seed, name);
+        if (this.levelData == null) {
+            this.levelData = new LevelData(seed, name);
             isNewWorld = true;
         }
 
-        if (dimensionData == null)
-        {
-            dimensionData = new DimensionData(this.worldType);
-            weatherManager = new WeatherManager(this);
-        }
-        else
-        {
-            weatherManager = new WeatherManager(this,
-                dimensionData.getCurrentWeather(),
-                dimensionData.getNextWeather(),
-                dimensionData.getWeatherDuration(),
-                dimensionData.getWeatherPower()
+        if (this.dimensionData == null) {
+            this.dimensionData = new DimensionData(this.worldType);
+            this.weatherManager = new WeatherManager(this);
+        } else {
+            this.weatherManager = new WeatherManager(this,
+                this.dimensionData.getCurrentWeather(),
+                this.dimensionData.getNextWeather(),
+                this.dimensionData.getWeatherDuration(),
+                this.dimensionData.getWeatherPower()
             );
         }
 
-        chunkProvider = createChunkProvider();
+        this.chunkProvider = createChunkProvider();
 
-        auroraProvider = new AuroraProvider(this, this.levelData.getRandomSeed());
+        this.auroraProvider = new AuroraProvider(this, this.levelData.getRandomSeed());
 
-        seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
+        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
 
-        biomeProvider = this.worldType.createBiomeProvider(this);
-        
-        if(isNewWorld)
-        {
+        this.biomeProvider = this.worldType.createBiomeProvider(this);
+
+        if (isNewWorld) {
             this.worldType.onWorldCreation(this);
             getInitialSpawnLocation();
         }
@@ -224,42 +215,38 @@ public class World implements MutableWorldSource {
     }
 
     //Usually called when going through portals
-    public World(World world, Dimension dimension)
-    {
-        lockTimestamp = world.lockTimestamp;
-        saveHandler = world.saveHandler;
+    public World(World world, Dimension dimension) {
+        this.lockTimestamp = world.lockTimestamp;
+        this.saveHandler = world.saveHandler;
 
-        levelData = new LevelData(world.levelData);
+        this.levelData = new LevelData(world.levelData);
 
-        dimensionData = world.saveHandler.getDimensionData(dimension.id);
-        if (dimensionData == null)
-        {
-            dimensionData = new DimensionData(dimension.defaultWorldType);
-            weatherManager = new WeatherManager(this);
-        }
-        else
-        {
-            weatherManager = new WeatherManager(this,
-                dimensionData.getCurrentWeather(),
-                dimensionData.getNextWeather(),
-                dimensionData.getWeatherDuration(),
-                dimensionData.getWeatherPower()
+        this.dimensionData = world.saveHandler.getDimensionData(dimension.id);
+        if (this.dimensionData == null) {
+            this.dimensionData = new DimensionData(dimension.defaultWorldType);
+            this.weatherManager = new WeatherManager(this);
+        } else {
+            this.weatherManager = new WeatherManager(this,
+                this.dimensionData.getCurrentWeather(),
+                this.dimensionData.getNextWeather(),
+                this.dimensionData.getWeatherDuration(),
+                this.dimensionData.getWeatherPower()
             );
         }
 
         // Set up info from dimension data
-        worldType = dimensionData.getWorldType();
+        this.worldType = this.dimensionData.getWorldType();
 
-        savedDataStorage = new SavedDataStorage(saveHandler);
+        this.savedDataStorage = new SavedDataStorage(this.saveHandler);
         this.dimension = dimension;
-        chunkProvider = createChunkProvider();
-        seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
+        this.chunkProvider = createChunkProvider();
+        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
 
-        biomeProvider = this.worldType.createBiomeProvider(this);
+        this.biomeProvider = this.worldType.createBiomeProvider(this);
 
         updateSkyBrightness();
 
-        auroraProvider = new AuroraProvider(this, this.getRandomSeed());
+        this.auroraProvider = new AuroraProvider(this, this.getRandomSeed());
 
         this.commandManager = new CommandManager(isServer);
         this.commandManager.init();
@@ -268,23 +255,22 @@ public class World implements MutableWorldSource {
     }
 
     //Usually called when joining a server
-    public World(LevelStorage saveHandler, String name, Dimension dimension, WorldType worldType, long seed)
-    {
+    public World(LevelStorage saveHandler, String name, Dimension dimension, WorldType worldType, long seed) {
         this.saveHandler = saveHandler;
-        levelData = new LevelData(seed, name);
+        this.levelData = new LevelData(seed, name);
         this.dimension = dimension;
-        dimensionData = new DimensionData(worldType);
+        this.dimensionData = new DimensionData(worldType);
         this.worldType = worldType;
-        savedDataStorage = new SavedDataStorage(saveHandler);
-        chunkProvider = createChunkProvider();
-        seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
+        this.savedDataStorage = new SavedDataStorage(saveHandler);
+        this.chunkProvider = createChunkProvider();
+        this.seasonManager = SeasonManager.fromConfig(this, this.worldType.getSeasonConfig());
         updateSkyBrightness();
 
         this.weatherManager = new WeatherManager(this);
 
-        auroraProvider = new AuroraProvider(this, this.levelData.getRandomSeed());
+        this.auroraProvider = new AuroraProvider(this, this.levelData.getRandomSeed());
 
-        biomeProvider = this.worldType.createBiomeProvider(this);
+        this.biomeProvider = this.worldType.createBiomeProvider(this);
 
         this.commandManager = new CommandManager(isServer);
         this.commandManager.init();
@@ -292,17 +278,16 @@ public class World implements MutableWorldSource {
         this.wireHandler = new WireHandler(this);
     }
 
-    public World(){
+    public World() {
         this.wireHandler = new WireHandler(this);
     }
 
-    public <T> T getGameRuleValue(GameRule<T> gameRule)
-    {
-        return levelData.getGameRules().getValue(gameRule);
+    public <T> T getGameRuleValue(GameRule<T> gameRule) {
+        return this.levelData.getGameRules().getValue(gameRule);
     }
 
     public SpawnerConfig getSpawnerConfig() {
-        return levelData.getSpawnerConfig();
+        return this.levelData.getSpawnerConfig();
     }
 
     @Override
@@ -310,177 +295,161 @@ public class World implements MutableWorldSource {
         return Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
     }
 
-    public BiomeProvider getBiomeProvider()
-    {
-        return biomeProvider;
+    public BiomeProvider getBiomeProvider() {
+        return this.biomeProvider;
     }
 
     public CommandManager getCommandManager() {
-        return commandManager;
+        return this.commandManager;
     }
 
     public @NotNull WireHandler getWireHandler() {
         return this.wireHandler;
     }
 
-    protected IChunkProvider createChunkProvider()
-    {
-        IChunkLoader chunkLoader = saveHandler.getChunkLoader(dimension);
+    protected IChunkProvider createChunkProvider() {
+        IChunkLoader chunkLoader = this.saveHandler.getChunkLoader(this.dimension);
         return accessor.createChunkProvider(this, chunkLoader);
     }
 
-    protected void getInitialSpawnLocation()
-    {
-        findingSpawnPoint = true;
+    protected void getInitialSpawnLocation() {
+        this.findingSpawnPoint = true;
         getWorldType().getInitialSpawnLocation(this);
-        findingSpawnPoint = false;
+        this.findingSpawnPoint = false;
     }
 
-    public void getRespawnLocation()
-    {
+    public void getRespawnLocation() {
         getWorldType().getRespawnLocation(this);
     }
 
-    public int getTopBlock(int x, int z)
-    {
-        int y = levelData.getSpawnY() - 1;
-        while (!isAirBlock(x, y + 1, z))
-        {
+    public int getTopBlock(int x, int z) {
+        int y = this.levelData.getSpawnY() - 1;
+        while (!isAirBlock(x, y + 1, z)) {
             y++;
         }
         return getBlockId(x, y, z);
     }
 
-    public void spawnPlayerWithLoadedChunks(Player player, boolean respawning)
-    {
-        try
-        {
+    public void spawnPlayerWithLoadedChunks(Player player, boolean respawning) {
+        try {
             if (!respawning) {
-                PlayerIO playerIO = saveHandler.getPlayerFileData();
+                PlayerIO playerIO = this.saveHandler.getPlayerFileData();
                 if (playerIO != null) {
                     playerIO.load(player);
                 }
             }
-            int chunkX = MathHelper.floor_float((int)player.x) / Chunk.CHUNK_SIZE_X;
-            int chunkZ = MathHelper.floor_float((int)player.z) / Chunk.CHUNK_SIZE_Z;
-            chunkProvider.setCurrentChunkOver(chunkX, chunkZ);
+            int chunkX = MathHelper.floor_float((int) player.x) / Chunk.CHUNK_SIZE_X;
+            int chunkZ = MathHelper.floor_float((int) player.z) / Chunk.CHUNK_SIZE_Z;
+            this.chunkProvider.setCurrentChunkOver(chunkX, chunkZ);
             entityJoinedWorld(player);
-        }
-        catch(Exception e)
-        {
+        } catch (Exception e) {
             LOGGER.error("Failed to spawn player with loaded chunks!", e);
         }
     }
 
-    public void saveWorld(boolean saveImmediately, ProgressListener progressUpdate, boolean saveLevelData)
-    {
-        if(!chunkProvider.canSave())
-        {
+    public void saveWorld(boolean saveImmediately, ProgressListener progressUpdate, boolean saveLevelData) {
+        if (!this.chunkProvider.canSave()) {
             return;
         }
 
-        if (saveLevelData){
-            if(progressUpdate != null)
-            {
+        if (saveLevelData) {
+            if (progressUpdate != null) {
                 progressUpdate.progressStart("Saving level data");
             }
 
             saveWorldData();
         }
-        
-        if(progressUpdate != null)
-        {
+
+        if (progressUpdate != null) {
             progressUpdate.progressStage("Saving chunks");
         }
-        chunkProvider.saveChunks(saveImmediately, progressUpdate);
+        this.chunkProvider.saveChunks(saveImmediately, progressUpdate);
 
-        if(progressUpdate != null)
-        {
+        if (progressUpdate != null) {
             progressUpdate.progressStop();
         }
     }
 
-    private void saveWorldData()
-    {
+    private void saveWorldData() {
         checkSessionLock();
-        saveHandler.saveLevelDataAndPlayerData(levelData, players);
-        saveHandler.saveDimensionData(this.dimension.id, dimensionData);
-        savedDataStorage.save();
+        this.saveHandler.saveLevelDataAndPlayerData(this.levelData, this.players);
+        this.saveHandler.saveDimensionData(this.dimension.id, this.dimensionData);
+        this.savedDataStorage.save();
     }
 
     public boolean pauseScreenSave(int i) {
-        if(!this.chunkProvider.canSave()) {
+        if (!this.chunkProvider.canSave()) {
             return true;
         }
-        if(i == 0) {
+        if (i == 0) {
             saveWorldData();
         }
         return this.chunkProvider.saveChunks(false, null);
     }
 
-    public @Nullable Weather getCurrentWeather()
-    {
-        return (weatherManager == null) ? null : weatherManager.getCurrentWeather();
+    public @Nullable Weather getCurrentWeather() {
+        return (this.weatherManager == null) ? null : this.weatherManager.getCurrentWeather();
     }
 
     @Override
-    public int getBlockId(final @NotNull TilePos tilePos) {
+    public int getBlockId(final @NotNull TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
             return 0;
         } else {
-            return this.getChunk(tilePos).getBlockId(tilePos.toChunkTilePos());
+            return this.getChunk(tilePos).getBlockId(new ChunkTilePos(tilePos));
         }
     }
 
     @Override
-    public @Nullable Block<?> getBlock(final @NotNull TilePos tilePos) {
+    public @Nullable Block<?> getBlock(final @NotNull TilePosc tilePos) {
         return Blocks.getBlock(this.getBlockId(tilePos));
     }
 
     @Override
-    public double getBlockTemperature(final @NotNull TilePos tilePos) {
-        if (tilePos.x < MIN_BLOCK_X || tilePos.z < MIN_BLOCK_Z || tilePos.x > MAX_BLOCK_X || tilePos.z > MAX_BLOCK_Z) {
+    public double getBlockTemperature(final @NotNull TilePosc tilePos) {
+        if (tilePos.x() < MIN_BLOCK_X || tilePos.z() < MIN_BLOCK_Z || tilePos.x() > MAX_BLOCK_X || tilePos.z() > MAX_BLOCK_Z) {
             return 0;
         } else {
-            final int chunkX = Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X);
-            final int chunkZ = Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z);
+            final int chunkX = Math.floorDiv(tilePos.x(), Chunk.CHUNK_SIZE_X);
+            final int chunkZ = Math.floorDiv(tilePos.z(), Chunk.CHUNK_SIZE_Z);
             double temperature = Double.NEGATIVE_INFINITY;
             @Nullable Chunk chunk = null;
 
             if (this.isChunkLoaded(chunkX, chunkZ)) {
                 chunk = this.getChunkFromChunkCoords(chunkX, chunkZ);
-                temperature = chunk.getBlockTemperature(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
+                temperature = chunk.getBlockTemperature(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
             }
 
             if (temperature == Double.NEGATIVE_INFINITY) {
-                temperature = getBiomeProvider().getTemperature(tilePos.x, tilePos.z);
+                temperature = getBiomeProvider().getTemperature(tilePos.x(), tilePos.z());
                 if (chunk != null) {
-                    chunk.setBlockTemperature(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), temperature);
+                    chunk.setBlockTemperature(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1), temperature);
                 }
             }
 
             return temperature;
         }
     }
+
     @Override
-    public double getBlockHumidity(final @NotNull TilePos tilePos) {
-        if (tilePos.x < MIN_BLOCK_X || tilePos.z < MIN_BLOCK_Z || tilePos.x > MAX_BLOCK_X || tilePos.z > MAX_BLOCK_Z) {
+    public double getBlockHumidity(final @NotNull TilePosc tilePos) {
+        if (tilePos.x() < MIN_BLOCK_X || tilePos.z() < MIN_BLOCK_Z || tilePos.x() > MAX_BLOCK_X || tilePos.z() > MAX_BLOCK_Z) {
             return 0;
         } else {
-            final int chunkX = Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X);
-            final int chunkZ = Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z);
+            final int chunkX = Math.floorDiv(tilePos.x(), Chunk.CHUNK_SIZE_X);
+            final int chunkZ = Math.floorDiv(tilePos.z(), Chunk.CHUNK_SIZE_Z);
             double humidity = Double.NEGATIVE_INFINITY;
             @Nullable Chunk chunk = null;
 
             if (this.isChunkLoaded(chunkX, chunkZ)) {
                 chunk = this.getChunkFromChunkCoords(chunkX, chunkZ);
-                humidity = chunk.getBlockHumidity(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
+                humidity = chunk.getBlockHumidity(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
             }
 
             if (humidity == Double.NEGATIVE_INFINITY) {
-                humidity = this.getBiomeProvider().getHumidity(tilePos.x, tilePos.z);
+                humidity = this.getBiomeProvider().getHumidity(tilePos.x(), tilePos.z());
                 if (chunk != null) {
-                    chunk.setBlockHumidity(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), humidity);
+                    chunk.setBlockHumidity(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1), humidity);
                 }
             }
 
@@ -494,24 +463,24 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public double getBlockVariety(final @NotNull TilePos tilePos) {
-        if (tilePos.x < MIN_BLOCK_X || tilePos.z < MIN_BLOCK_Z || tilePos.x > MAX_BLOCK_X || tilePos.z > MAX_BLOCK_Z) {
+    public double getBlockVariety(final @NotNull TilePosc tilePos) {
+        if (tilePos.x() < MIN_BLOCK_X || tilePos.z() < MIN_BLOCK_Z || tilePos.x() > MAX_BLOCK_X || tilePos.z() > MAX_BLOCK_Z) {
             return 0;
         } else {
-            final int chunkX = Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X);
-            final int chunkZ = Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z);
+            final int chunkX = Math.floorDiv(tilePos.x(), Chunk.CHUNK_SIZE_X);
+            final int chunkZ = Math.floorDiv(tilePos.z(), Chunk.CHUNK_SIZE_Z);
             double variety = Double.NEGATIVE_INFINITY;
             @Nullable Chunk chunk = null;
 
             if (this.isChunkLoaded(chunkX, chunkZ)) {
                 chunk = this.getChunkFromChunkCoords(chunkX, chunkZ);
-                variety = chunk.getBlockVariety(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
+                variety = chunk.getBlockVariety(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
             }
 
             if (variety == Double.NEGATIVE_INFINITY) {
-                variety = this.getBiomeProvider().getVariety(tilePos.x, tilePos.z);
+                variety = this.getBiomeProvider().getVariety(tilePos.x(), tilePos.z());
                 if (chunk != null) {
-                    chunk.setBlockVariety(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), variety);
+                    chunk.setBlockVariety(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1), variety);
                 }
             }
 
@@ -520,25 +489,24 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public @NotNull Biome getBlockBiome(final @NotNull TilePos tilePos)
-    {
+    public @NotNull Biome getBlockBiome(final @NotNull TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
             return Biomes.OVERWORLD_PLAINS;
         } else {
-            final int chunkX = Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X);
-            final int chunkZ = Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z);
+            final int chunkX = Math.floorDiv(tilePos.x(), Chunk.CHUNK_SIZE_X);
+            final int chunkZ = Math.floorDiv(tilePos.z(), Chunk.CHUNK_SIZE_Z);
             @Nullable Biome biome = null;
             @Nullable Chunk chunk = null;
 
             if (this.isChunkLoaded(chunkX, chunkZ)) {
                 chunk = this.getChunkFromChunkCoords(chunkX, chunkZ);
-                biome = chunk.getBlockBiome(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
+                biome = chunk.getBlockBiome(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1));
             }
 
             if (biome == null) {
-                biome = this.getBiomeProvider().getBiome(tilePos.x, tilePos.y, tilePos.z);
+                biome = this.getBiomeProvider().getBiome(tilePos.x(), tilePos.y(), tilePos.z());
                 if (chunk != null) {
-                    chunk.setBlockBiome(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), biome);
+                    chunk.setBlockBiome(tilePos.x() & (Chunk.CHUNK_SIZE_X - 1), tilePos.y(), tilePos.z() & (Chunk.CHUNK_SIZE_Z - 1), biome);
                 }
             }
 
@@ -548,12 +516,11 @@ public class World implements MutableWorldSource {
         }
     }
 
-    public boolean getBlockLitInteriorSurface(final @NotNull TilePos tilePos)
-    {
+    public boolean getBlockLitInteriorSurface(final @NotNull TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
             return true;
         } else {
-            return Block.getIsLitInteriorSurface(this, tilePos.x, tilePos.y, tilePos.z);
+            return Block.getIsLitInteriorSurface(this, tilePos);
         }
     }
 
@@ -562,7 +529,7 @@ public class World implements MutableWorldSource {
         return this.getBlockLitInteriorSurface(new TilePos(x, y, z));
     }
 
-    public boolean isAirBlock(final @NotNull TilePos tilePos) {
+    public boolean isAirBlock(final @NotNull TilePosc tilePos) {
         return this.getBlockId(tilePos) == 0;
     }
 
@@ -571,11 +538,11 @@ public class World implements MutableWorldSource {
         return this.isAirBlock(new TilePos(x, y, z));
     }
 
-    public boolean isBlockLoaded(final @NotNull TilePos tilePos) {
+    public boolean isBlockLoaded(final @NotNull TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.isChunkLoaded(tilePos.toChunkPos());
+            return this.isChunkLoaded(new ChunkPos(tilePos));
         }
     }
 
@@ -584,8 +551,8 @@ public class World implements MutableWorldSource {
         return this.isBlockLoaded(new TilePos(x, y, z));
     }
 
-    public boolean areBlocksLoaded(final @NotNull TilePos tilePos, final int range) {
-        return this.areBlocksLoaded(tilePos.sub(range, range, range), tilePos.add(range, range, range));
+    public boolean areBlocksLoaded(final @NotNull TilePosc tilePos, final int range) {
+        return this.areBlocksLoaded(tilePos.sub(range, range, range, new TilePos()), tilePos.add(range, range, range, new TilePos()));
     }
 
     @Deprecated
@@ -593,11 +560,11 @@ public class World implements MutableWorldSource {
         return this.areBlocksLoaded(new TilePos(x, y, z), range);
     }
 
-    public boolean areBlocksLoaded(final @NotNull TilePos min, final @NotNull TilePos max) {
-        int minX = Math.min(min.x, max.x);
-        int minZ = Math.min(min.z, max.z);
-        int maxX = Math.max(min.x, max.x);
-        int maxZ = Math.max(min.z, max.z);
+    public boolean areBlocksLoaded(final @NotNull TilePosc min, final @NotNull TilePosc max) {
+        int minX = Math.min(min.x(), max.x());
+        int minZ = Math.min(min.z(), max.z());
+        int maxX = Math.max(min.x(), max.x());
+        int maxZ = Math.max(min.z(), max.z());
 
         minX >>= 4;
         minZ >>= 4;
@@ -631,8 +598,8 @@ public class World implements MutableWorldSource {
         return this.isChunkLoaded(new ChunkPos(x, z));
     }
 
-    public @NotNull Chunk getChunk(final @NotNull TilePos tilePos) {
-        return this.getChunk(tilePos.toChunkPos());
+    public @NotNull Chunk getChunk(final @NotNull TilePosc tilePos) {
+        return this.getChunk(new ChunkPos(tilePos));
     }
 
     @Deprecated
@@ -654,15 +621,15 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public boolean setBlockIdData(final @NotNull TilePos tilePos, final int id, final int data) {
+    public boolean setBlockIdData(final @NotNull TilePosc tilePos, final int id, final int data) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockIdData(tilePos.toChunkTilePos(), id, data);
+            return this.getChunk(tilePos).setBlockIdData(new ChunkTilePos(tilePos), id, data);
         }
     }
 
-    public boolean setBlockIdRaw(final @NotNull TilePos tilePos, final int id) {
+    public boolean setBlockIdRaw(final @NotNull TilePosc tilePos, final int id) {
         return this.setBlockIdDataRaw(tilePos, id, this.getBlockData(tilePos));
     }
 
@@ -671,11 +638,11 @@ public class World implements MutableWorldSource {
         return this.setBlockIdRaw(new TilePos(x, y, z), id);
     }
 
-    public boolean setBlockIdDataRaw(final @NotNull TilePos tilePos, final int id, final int data) {
+    public boolean setBlockIdDataRaw(final @NotNull TilePosc tilePos, final int id, final int data) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockIdDataRaw(tilePos.toChunkTilePos(), id, data);
+            return this.getChunk(tilePos).setBlockIdDataRaw(new ChunkTilePos(tilePos), id, data);
         }
     }
 
